from WikidataTemplater.DBHandler import DBhandler
from WikidataTemplater.WDhandler import WDhandler
from WikidataTemplater.Route import Route
from WikidataTemplater.DataModel import DataModel
from WikidataTemplater.main import Settings
import json

s = Settings()
FALLBACK_LANGUAGE = s.settings["FALLBACK_LANGUAGE"]
HOME_VARIABLE = s.settings["HOME_VARIABLE"]


class xBreadcrumb():
    def __init__(self, cookie = "/", language = FALLBACK_LANGUAGE):
        self.dml = DataModel()
        self.dbh = DBhandler()
        self.language = language
        self.string = cookie
        self.presentation = []
        self.breadcrumb = self.build_breadcrumb()

    def get_breadcrumb(self, breadcrumb_string):
        '''
            breadcrumb_string format:
        '''
        self.string = breadcrumb_string
        if self.string is None:
            self.string = "/"
        return self.string


    def build_breadcrumb(self):
        l = []
        a = self.string.split("/")
        for i,e in enumerate(a):
            breadcrumb_item = {}
            aa = e.split("|")
            breadcrumb_item["label"] = self.get_label(aa[0])
            breadcrumb_item["uri"] = "/".join(a[0:i])
            if len(aa) > 1 :
                breadcrumb_item["label"] = self.get_wd_label(aa[1])
            l.append(breadcrumb_item.copy())
        return l.copy()

    def get_label(self, entity):
        
        r = self.dml.select((entity, "?label_" + self.language , None))
        if r:
            return r[0][2]
        else:
            label =  entity[1:]
            label = label[0:1].upper() + label[1:].lower()
            return label
    
    def get_wd_label(self,entity):
        q = "select label from routes where wdid = '" +entity.lower() + "' and language = '" + self.language + "'"
        r = self.dbh.get(q)
        if len(r) > 0:
            return r[0]
        else:
            return entity    




 


