
import sqlite3, typing
from WikidataTemplater.main import Settings

s = Settings()
DATABASE= s.settings["DATABASE"]

class DBhandler():
    '''Manages queries to the database '''
    def __init__(self):
        self.conn = sqlite3.connect(DATABASE)
        self.conn.row_factory = sqlite3.Row
    
    def __del__(self):
        self.conn.close()
    
    def delete(self, query: str) -> int:
        """ executes a delete sql query

        Args:
            query (str): the query

        Returns:
            int: number of affected rows
        """        
        r = self.conn.execute(query)
        rowcount = r.rowcount
        self.conn.commit()
        return rowcount
    
    def delete_by_id (self, table: str, id: int) -> int:
        query: str = "delete from " + table + " where id = " + str(id)
        return self.delete(query)
        
    
    def get(self,query,fetch = 'fetchone'):
        if fetch == "fetchone":
            r = self.conn.execute(query).fetchone()
            if r is None:
                return None
            else:
                return r
        else:
            r = self.conn.execute(query).fetchall()
            if r is None:
                return None
            else:
                return r
            
    def select(self, query, fetch = 'fetchone'):
        return self.get(query,fetch)
        
    def execute(self, query: str):
        self.conn.execute(query)
        
    def insert(self, q, values):
        self.conn.execute(q,values)
        self.conn.commit()
        pass
    
    def update(self, query: str) -> int:
        r = self.conn.execute(query)
        rowcount = r.rowcount
        self.conn.commit()
        return rowcount