#from WikidataTemplater.DBHandler import DBHandler
from WikidataTemplater.main import Settings

s = Settings()
FALLBACK_LANGUAGE= s.settings["FALLBACK_LANGUAGE"]

class Presentation():
    ''' renders partial html'''
    def __init__(self):
        pass

    def render_image(self, **kwargs):
        r = '<img src="' + kwargs["value"] + '" class="card-image " / >'
        if "link" in kwargs.keys():
            r = '< a href = "'+ kwargs["link"] + '" target ="" >' + r + '</a>'
        return r
    
    def render_image_placeholder(self):
        #r = '''<svg class="bd-placeholder-img card-img-top" width="100%" height="180" xmlns="http://www.w3.org/2000/svg" role="img" aria-label="Placeholder" preserveAspectRatio="xMidYMid slice" focusable="false">
         #       <title>Placeholder</title>
         #       <rect width="100%" height="100%" fill="#eee"></rect></svg>'''
        return ""
    
    def render_title(self, **kwargs):
        r = '<h4 class = "card-title placeholder-glow"><figurecaption> '
        r += kwargs["value"]
        r += '</figurecaption></h3>'
        if 'route' in kwargs.keys():
            r = '<a href="' + kwargs['route']+ '" class="" >' + r + '</a>'
        return r

    def render_description(self, **kwargs):
        r = '<p class = "card-subtitle mb-2 text-body-secondary placeholder-glow"><subtitle>'
        r += kwargs["value"]
        r += '</subtitle></p>'
        return r
    
    def render_text(self, **kwargs):
        
        if kwargs["value"][0:1] == "?":

            r = '<li class = "list-group-item">'
            r += '<a href= "' + kwargs["uri"] + '" > ' + kwargs['label'] + '</a>'
            r += '</li>'
        else:
            r = '<p class = "">'
            r += kwargs["value"]
            r += '</p>'
        
        return r
    
    def render_wd_link(self, **kwargs):
        r = '<button href="' + kwargs["value"] + '" target= "_blank" class = "badge  btn-secondary btn-sm  ">'
        r += kwargs["value"].split("/")[-1:][0]
        r += '</button>'
        return r

    def render_from_to(self, start, end):
        r = '<p>' + start + " – " + end + '</p>'
        return r

    def render_archive(self, language = FALLBACK_LANGUAGE, **kwargs):
    
        if len(kwargs["value"]) > 0:
            a = list(set(kwargs["value"].split("|")))
            
            r = ""
            for e in a:
                aa = e.split("~")
                if aa[-1:][0] == language :
                    if len(aa) == 3:
                        r += '<span href="'+ aa[0] +'"  target= "_blank" type="button" class="badge d-inline-block btn-secondary text-wrap m-2">' + aa[1] + '</span'
                    elif len(aa) == 4:
                        r += '<span href="'+ aa[0] +'"  target= "_blank" type="button" class="badge d-inline-block btn-secondary text-wrap m-2">' + aa[1] + \
                            '<div class="badge btn-primary text-wrap">' + aa[2] + ' </div></span>'
                else:
                    pass
            return r
        return ""

    def render_sources(self, **kwargs):
        count_sources = len(kwargs["value"].split("|")) 
        if count_sources > 0:
            return '<span class="badge badge-success ps-3 position-relative">' + str(count_sources) +'</span>'
        else:
            return ""

