from flask import Flask, render_template, request, make_response 
import json
#import pandas as pd
from WikidataTemplater.Route import Route
from WikidataTemplater.Query import Query
from WikidataTemplater.View import View
from WikidataTemplater.ListView import ListView
from WikidataTemplater.TableView import TableView
from WikidataTemplater.ItemView import ItemView
from WikidataTemplater.DataModel import DataModel
from WikidataTemplater.Render import Render
from flask_bootstrap import Bootstrap5
import logging

app = Flask(__name__, template_folder='templates', static_folder='static')
Bootstrap5(app)
app.config['BOOTSTRAP_SERVE_LOCAL'] = True 


@app.errorhandler(500)
def error_page(e):
    return render_template('errorpage.html')

@app.errorhandler(502)
def error_page(e):
    return render_template('errorpage.html')

@app.errorhandler(504)
def error_page(e):
    return render_template('errorpage.html')
        
@app.route('/', defaults={'path': ''})
def index(path):
    return render_template('index.html')

@app.route('/de', defaults={'path': ''})
def index_de(path):
    return render_template('index.html')

@app.route('/en', defaults={'path': ''})
def index_en(path):
    return render_template('index_en.html')

@app.route('/fr', defaults={'path': ''})
def index_fr(path):
    return render_template('index_fr.html')

@app.route('/schlüssel')    # should be modified in production
def custom():
    #return render_template('costum.html')
    print("route rst")
    dtm = DataModel()
    rnd = Render()
    qry = Query()
    vw = View()
    rte = Route()
    
    rnd.import_templates()
    dtm.import_statements()
    qry.import_templates()
    vw.clear_cache()
    rte.clear_routes()
    rnd.build_template_descriptions()
    return render_template("index.html")




@app.route('/<path:path>')
def list(path):
    breadcrumb_string =  request.cookies.get('breadcrumb')
    rte = Route()
    template, filters, language, title, description, cached = rte.parse_route(path)
    if not template:
        return render_template("index.html")
    qy = Query()
    qy.set(template, filters,language)
    
    vw = View(qy.query, path, language, title, description,cached)
    if  vw.is_table():
        tvw = TableView(vw)
        tvw.title = vw.render_title(qy.filters,tvw.title)
        tvw.description = vw.render_description (qy.filters,tvw.description )
        resp = make_response(render_template('table.html', results=tvw))
        return resp
        
    if not vw.is_card():
        lvw = ListView(vw)
        lvw.sort_by = request.cookies.get('sort_by')
        if lvw.sort_by is None:
            lvw.sort_by = 'itemLabel|1'
        lvw.order_by()
        filter = request.cookies.get('filter')
        page = request.cookies.get('page') 
        if lvw.route == request.cookies.get('route'):
            page: str =  page
        else:
            page: str =  '1'
            lvw.sort_by = 'itemLabel|1'
            filter: str = ""
        if filter is not None:
            lvw.get_filter(filter)
        if page is not None and page.isnumeric():
            lvw.paginate(page)
        else:
            lvw.paginate()
        lvw.title = lvw.render_title(qy.filters,lvw.title)
        lvw.description = lvw.render_description (qy.filters,lvw.description )
        lvw.export_link = lvw.render_export_link()
        lvw.render_items(rte.path)
        lvw.get_search_index()
        resp = make_response(render_template('card.html', results=lvw))
        resp.set_cookie("breadcrumb", str())
        resp.set_cookie("route", lvw.route[1:] + "/" + lvw.language )
        resp.set_cookie('sort_by', lvw.sort_by)
        resp.set_cookie("page", page)
        resp.set_cookie("filter", filter)
        return resp
    else:
        svw = ItemView(vw)
        return render_template('single_object.html', results=svw)


if __name__ == "__main__":
    app.run(host='0.0.0.0:3000')