import yaml, os, sys
import sqlite3, json, urllib.parse


st_drop = "DROP TABLE IF EXISTS data_model" 
st_create =  '''
                CREATE TABLE data_model (
                    subject TEXT NOT NULL,
                    predicate TEXT NOT NULL,
                    object TEXT NOT NULL,
                    object_label TEXT

                );
                '''

abspath = os.path.abspath(sys.argv[0])
dname = os.path.dirname(abspath)
os.chdir(dname)

with open('../data_model.yml') as f:
    data_model = yaml.load(f, Loader=yaml.FullLoader)

connection = sqlite3.connect('../database.sqlite')
connection.execute(st_drop)
connection.execute(st_create)


cur = connection.cursor()

q = "INSERT INTO data_model (subject, predicate, object, object_label) VALUES (?,?,?,?)"

for e in data_model["statements"]:
    a = e.split(" ")
    subject = a[0]
    predicate = a[1]
    object = a[2]
    if len(a) == 4:
        object_label = a[3]
    else:
        object_label = ""
    cur.execute(q, (subject, predicate, object, object_label))

    




connection.commit()
connection.close()


