#!/usr/bin/python3

from WikidataTemplater.WDhandler import  WDhandler
from WikidataTemplater.DBHandler import DBhandler

class Work():
    '''different mantainance task'''

    def __init__(self) -> None:
        self.wdid_list = []
        self.response = []
        pass

    def load_corpus(self):
        '''loads corpus data into route table'''
        wdh =  WDhandler()
        dbh = DBhandler()
        q = '''SELECT DISTINCT ?item ?itemLabel ?itemDescription ?instance where 
		{ ?item (wdt:P17|wdt:P19|wdt:P20|wdt:P27|wdt:P36|wdt:P119|wdt:P131|wdt:P159|wdt:P180|wdt:P189|wdt:P276|wdt:P279|wdt:P291|wdt:P361|
		wdt:P551|wdt:P740|wdt:P915|wdt:P840|wdt:P921|wdt:P937|
		wdt:P1001|wdt:P1071|wdt:P1269|wdt:P1376|wdt:P1416|
		wdt:P2341|wdt:P2541|wdt:P2647|wdt:P2650)/(wdt:P31*|wdt:P361*|wdt:P131*|wdt:P279*) wd:Q329618 . 
         ?item wdt:P31 ?instance.
		SERVICE wikibase:label { bd:serviceParam wikibase:language "de,de,en, fr". } } order by ?item'''
        r = wdh.get(q)
        self.response = r["results"]['bindings']
        l = len(self.response)
        self.aggregate_instances()
        for i,e in enumerate(r["results"]['bindings']):

            wdid = e['item']['value'].split("/")[-1:][0]
            print (wdid, "WDID")
            if wdid not in ("Q701025", "Q675321", "Q668294", "Q30607493", "Q1721466", "Q165008", "Q161062", "Q153963", "Q153665", "Q15057620"):
                if not self.exists(wdid):
                    label = e['itemLabel']['value']
                    label_encoded = label.lower().replace(" ", "_")
                    if 'xml:lang' in e['itemLabel']:
                        language = e['itemLabel']['xml:lang']
                    else:
                        language = "?"
                    instance_of = self.get_instance(wdid)
                    #print (wdid, label, i, l , "\n----------------------")
                    q = "INSERT INTO routes (wdid, label, label_encoded, language, instance_of, status) VALUES (?,?,?,?,?,?)"
                    v = (wdid, label, label_encoded, language, instance_of, "g")
                    dbh.insert(q,v)

    def aggregate_instances(self):
        for e in self.response:
            wdid = self.get_wdid(e["item"]["value"])
            instance = self.get_wdid(e["instance"]["value"])
            found = [x for x in self.wdid_list if x[0] == wdid]
            if len(found) > 0:
                found[0][1] += "," + instance
            else:
                self.wdid_list.append([wdid, instance])
            
        
    def exists(self, wdid):
        dbh = DBhandler()
        q = "select wdid from routes where wdid = '" + wdid + "'"
        r = dbh.get(q)
        if not r :
            return False
        else: 
            return True

    def get_instance(self, wdid):
        found = [x for x in self.wdid_list if x[0] == wdid]
        if len(found) > 0:
            #print (found, "FOUND")
            instances = found[0][1].split(",")
            if "Q5" in instances:
                return "Q5"
            else:
                numbers = [int(x[1:]) for x in instances]
                return "Q" + str(min(numbers))
        else:
            print(self.wdid_list)
        
    def get_wdid(self, url):
        return url.split("/")[-1:][0]

if __name__ == "__main__":
    wrk = Work()
    wrk.load_corpus()